#!/usr/bin/env python

# Inspire by Conbagui's  tutorial found here: http://fav.me/d9vlx7y

# author: Pocholo
# date: 6/6/20

# Comments directed to http://gimpchat.com

# With the help of MareroQ 

# Installation:
# This script should be placed in the user plugins folder

# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.

#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>.


from gimpfu import *

def pm_conbagui_welded_Text(customtext, fontname, fontsize, justify, linespa):

	#Initiates the temporary state
	pdb.gimp_context_push()
	
	#Create a new image
	img = pdb.gimp_image_new(1, 1, RGB_IMAGE)
	
	#Variables
	width = img.width
	height = img.height
			
	#Create the text
	pdb.gimp_context_set_foreground((44, 35, 35))
	textLayer = pdb.gimp_text_fontname(img, None, 0, 0, customtext, 50, 
										TRUE, fontsize, PIXELS, fontname)
	pdb.gimp_text_layer_set_line_spacing(textLayer, linespa)
	pdb.gimp_text_layer_set_justification(textLayer, justify)
	
	#Resize text
	img.resize(textLayer.width, textLayer.height, 0, 0)
	
	pdb.gimp_display_new(img)
	
	#Create the dark metal background
	backlayer = pdb.gimp_layer_new(img, img.width, img.height, RGB_IMAGE, "Background", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, backlayer, 1)
	pdb.gimp_layer_add_alpha(backlayer)
	pdb.gimp_context_set_pattern("Metal with holes small.")
	pdb.gimp_edit_bucket_fill(backlayer, BUCKET_FILL_PATTERN, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
	pdb.gimp_context_set_pattern("Metal grid-1")
	pdb.gimp_edit_bucket_fill(backlayer, BUCKET_FILL_PATTERN, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
	backcopy = pdb.gimp_layer_new(img, img.width, img.height, RGB, "Background copy", 100, LAYER_MODE_MULTIPLY)
	pdb.gimp_image_add_layer(img, backcopy, 1)
	pdb.gimp_layer_add_alpha(backcopy)
	pdb.gimp_context_set_pattern("Metal with holes small.")
	pdb.gimp_edit_bucket_fill(backcopy, BUCKET_FILL_PATTERN, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
	backLayer = pdb.gimp_image_merge_down(img, backcopy, CLIP_TO_IMAGE)
	
	#Duplicate the text	
	non_empty = pdb.gimp_edit_copy(textLayer)
	textcopy = pdb.gimp_layer_new(img, img.width, img.height, RGB, "Text copy", 100, LAYER_MODE_SCREEN)
	pdb.gimp_image_add_layer(img, textcopy, 0)
	pdb.gimp_layer_add_alpha(textcopy)
	pdb.gimp_drawable_fill(textcopy, FILL_TRANSPARENT)
	floating_sel = pdb.gimp_edit_paste(textcopy, FALSE)
	pdb.gimp_floating_sel_anchor(floating_sel)
	
	#Grow text
	pdb.gimp_image_select_item(img, 2, textLayer)
	pdb.gimp_selection_grow(img, 2)
	pdb.gimp_context_set_foreground((44, 35, 35))
	pdb.gimp_edit_bucket_fill(textcopy, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
	pdb.gimp_selection_none(img)
	
	#Apply layerfx
	#Drop Shadow
	pdb.python_layerfx_drop_shadow(img, textLayer,
									     (0, 0, 0),   #color
												75,   #opacity
												 0,   #contou - linear
												 0,   #noise
												 3,   #mode - multiply   
												 0,   #spread
												 7,   #size
											   120,   #offset_angle
												 9,   #offset_distance
											  TRUE,   #knockout
											 FALSE)   #merge
		
	#Inner Glow								   
	pdb.python_layerfx_inner_glow(img, textLayer, 
								     (24, 85, 35),   #color
											   75,   #opacity
									 		    0,   #contou
											    0,   #noise
								                5,   #mode - overlay
											    0,   #source
											    0,   #choke 
											    6,   #size 
										     TRUE)   #merge
	
	textLayer = pdb.gimp_image_get_active_layer(img)
	#Bevel and emboss
	pdb.python_layerfx_bevel_emboss(img, textLayer, 
												  1,   #style inner bevel
												 65,   #depth 
												  0,   #direction 
												  7,   #size 
												  1,   #soften
												 50,   #angle 
												 58,   #altitude 
												  0,   #gloss_contour- linear 
								    (153, 210, 251),   #highlight_color 
												  5,   #highlight_mode - overlay
												 80,   #highlight_opacity
										    "Black",   #shadow_color 
												  3,   #shadow_mode - multyply
											 	 25,   #shadow_opacity 
												  0,   #surface_contour - linear 
											   TRUE,   #use_texture 
									   "Rough wall",   #pattern 
											     50,   #scale 
											    100,   #tex_depth 
											   TRUE,   #invert 
											   TRUE)   #merge
	
	textLayer = pdb.gimp_image_get_active_layer(img)
	#Bevel and emboss
	pdb.python_layerfx_bevel_emboss(img, textLayer, 
												  1,   #style inner bevel
												 65,   #depth 
												  0,   #direction 
												  7,   #size 
												  1,   #soften
												 55,   #angle 
												 30,   #altitude 
												  0,   #gloss_contour- linear 
								    (255, 255, 255),   #highlight_color 
												  5,   #highlight_mode - overlay
												 45,   #highlight_opacity
										    "Black",   #shadow_color 
												  3,   #shadow_mode - multyply
											 	 35,   #shadow_opacity 
												  0,   #surface_contour - linear 
											   TRUE,   #use_texture 
									   "Rough wall",   #pattern 
											     50,   #scale 
											    100,   #tex_depth 
											   TRUE,   #invert 
											   TRUE)   #merge
	
	textLayer = pdb.gimp_image_get_active_layer(img)
	#Pattern overlay		
	pdb.python_layerfx_pattern_overlay(img, textLayer, 
										   "Lava.jpg",   #pattern
												  100,   #opacity
												    6,   #mode - different
												   30,   #scale
													0,   #interpolation
												 TRUE)   #merge
	
	textLayer = pdb.gimp_image_get_active_layer(img)
	#Pattern overlay		
	pdb.python_layerfx_pattern_overlay(img, textLayer, 
									   "Lava.jpg",   #pattern
											  100,   #opacity
											   18,   #mode - hard light
											   20,   #scale
												0,   #interpolation
											FALSE)   #merge
	
	
	#Apply the wave filter to the text copy
	pdb.plug_in_waves(img, textcopy, 
	                           2.00,   #amplitude 
							  76.00,   #phase 
								 50,   #wavelength 
								  0,   #type - smear
							  FALSE)   #reflective
	
	
	#Apply layerfx to the text copy
	#Inner Shadow
	pdb.python_layerfx_inner_shadow(img, textcopy, 
									 (0, 0, 0),   #color
									        55,   #opacity
										     1,   #contou
										     0,   #noise
										     3,   #mode - multiply
										     1,   #source
										     0,   #choke 
									         6,   #size 
										   -77,   #offset_angle 
										     5,   #offset_distance 
									      TRUE)  #merge
	
	
	textcopy = pdb.gimp_image_get_active_layer(img)
	#Inner Glow								   
	pdb.python_layerfx_inner_glow(img, textcopy, 
								     (51, 48, 58),   #color
											   75,   #opacity
									 		    0,   #contou
											    0,   #noise
								                5,   #mode - overlay
											    0,   #source
											    0,   #choke 
											    6,   #size 
										     TRUE)   #merge
	
	textcopy = pdb.gimp_image_get_active_layer(img)
	pdb.gimp_layer_set_mode(textcopy, LAYER_MODE_SCREEN)
	#Bevel and emboss
	pdb.python_layerfx_bevel_emboss(img, textcopy, 
												  1,   #style inner bevel
												 65,   #depth 
												  0,   #direction 
												 10,   #size 
												  1,   #soften
												 55,   #angle 
												 58,   #altitude 
												  0,   #gloss_contour- linear 
								    (255, 255, 255),   #highlight_color 
												  5,   #highlight_mode - overlay
												 75,   #highlight_opacity
										    "Black",   #shadow_color 
												  5,   #shadow_mode - overlay
											 	 80,   #shadow_opacity 
												  0,   #surface_contour - linear 
											   TRUE,   #use_texture 
									   "Rough wall",   #pattern 
											    100,   #scale 
											     10,   #tex_depth 
											   TRUE,   #invert 
											  FALSE)   #merge
		
	textcopy = pdb.gimp_image_get_active_layer(img)
	#Outer glow
	pdb.python_layerfx_outer_glow(img, textcopy, 
								  (231, 17, 2),   #color
											 100,   #opacity
											   0,   #contou
											   0,   #noise
											  16,   #mode - dodge
											  10,   #spread 
											  15,   #size 
											TRUE,   #knockout 
										   FALSE)   #merge	
	
	
	
	#select the text copy outer glow
	layer = pdb.gimp_image_get_layer_by_name(img, "Text copy-outerglow")
	#Pattern overlay		
	pdb.python_layerfx_pattern_overlay(img, layer, 
									   "Lava.jpg",   #pattern
											  100,   #opacity
												0,   #mode - normal
											   30,   #scale
												0,   #interpolation
											FALSE)   #merge
		
	pdb.gimp_image_set_active_layer(img, backLayer)
	
	#Resets the previous user defaults
	pdb.gimp_context_pop()
	
register(
	"pm_conbagui_welded_Text",
	"Creates a welded text",
	"Creates a welded text with sparks",
	"Pocholo",
	"Pocholo",
	"2020",
	"PM Conbagui's Welded text",
	"",
[	
	(PF_TEXT, "customtext", "Text string", 'WELDED'),
	(PF_FONT, "font", "Font name", "Parley bold, Bold"),
	(PF_ADJUSTMENT, "fontsize", "Size", 450, (300, 450, 1)),
	(PF_OPTION, "justify", "Justify", 2, ("Left", "Right", "Centered", "Fill")),
	(PF_ADJUSTMENT, "linespa", "Line spacing", -25, (-100, 100, 1)),
],
[],
pm_conbagui_welded_Text, menu="<Image>/Pocholo-scripts/PM Conbagui's Welded text")
main()	